{*******************************************************}
{                                                       }
{       Winsent Net Send SDK                            }
{                                                       }
{       Winsent Net Send SDK Library Interface Unit     }
{                                                       }
{       Copyright (c) 2010-2014, Winsent Lab            }
{       http://www.winsentlab.com                       }
{                                                       }
{                                                       }
{*******************************************************}
unit wsNetSendLib;

interface

uses
  Windows;

const
  WSNS_RESULT_SUCCESS           	= 0;
  WSNS_RESULT_NOTINITIALIZED		= 1;
  WSNS_RESULT_ALREADYINITIALIZED	= 2;

  WSNS_RESULT_SENDUNKNOWNERROR          = 101;
  WSNS_RESULT_SENDRECIPIENTNOTFOUND     = 102;
  WSNS_RESULT_SENDTRANSMISSIONERROR     = 103;
  WSNS_RESULT_SENDNOINTERFACEAVAIL	    = 104;

  WSNS_STATE_UNKNOWN                    = 0;
  WSNS_STATE_NONETWORK                  = 1;
  WSNS_STATE_INACTIVE                   = 2;
  WSNS_STATE_ACTIVATION                 = 3;
  WSNS_STATE_ACTIVE                     = 4;

type
  PFNCallbackNewMsg = procedure(const aFrom, aTo, aMsg: LPCTSTR ); stdcall;

function NetsendUnicastInitialize():integer; stdcall;
function NetsendUnicastFinalize():integer; stdcall;
function NetsendUnicastActivate():integer; stdcall;
function NetsendUnicastDeactivate():integer; stdcall;
function NetsendUnicastAddName( const aName: LPCTSTR ):integer; stdcall;
function NetsendUnicastDelName( const aName: LPCTSTR ):integer; stdcall;
function NetsendUnicastSetOnNewMsg( aCallback: PFNCallbackNewMsg  ):integer; stdcall;
function NetsendUnicastSendMsg( aAddr, aMsg: LPCTSTR ):integer; stdcall;
function NetsendUnicastSendMsgEx( aAddr, aMsg, aSign: LPCTSTR ):integer; stdcall;
function NetsendUnicastGetState( const aName: LPCTSTR; aState: PDWORD ):integer; stdcall;
function NetsendUnicastSetSendTimeout( aTimeout: DWORD  ):integer; stdcall;

function NetsendBroadcastInitialize():integer; stdcall;
function NetsendBroadcastFinalize():integer; stdcall;
function NetsendBroadcastActivate():integer; stdcall;
function NetsendBroadcastDeactivate():integer; stdcall;
function NetsendBroadcastSetOnNewMsg( aCallback: PFNCallbackNewMsg  ):integer; stdcall;
function NetsendBroadcastSendMsg( aAddr, aMsg: LPCTSTR ):integer; stdcall;
function NetsendBroadcastSendMsgEx( aAddr, aMsg, aSign: LPCTSTR ):integer; stdcall;
function NetsendBroadcastGetState( aState: PDWORD ):integer; stdcall;


implementation

{$IFDEF UNICODE}
function NetsendUnicastInitialize; external 'wsnslib.dll' name 'NetsendUnicastInitializeW';stdcall;
function NetsendUnicastFinalize; external 'wsnslib.dll' name 'NetsendUnicastFinalizeW';stdcall;
function NetsendUnicastActivate; external 'wsnslib.dll' name 'NetsendUnicastActivateW';stdcall;
function NetsendUnicastDeactivate; external 'wsnslib.dll' name 'NetsendUnicastDeactivateW';stdcall;
function NetsendUnicastAddName; external 'wsnslib.dll' name 'NetsendUnicastAddNameW';stdcall;
function NetsendUnicastDelName; external 'wsnslib.dll' name 'NetsendUnicastDelNameW';stdcall;
function NetsendUnicastSetOnNewMsg; external 'wsnslib.dll' name 'NetsendUnicastSetOnNewMsgW';stdcall;
function NetsendUnicastSendMsg; external 'wsnslib.dll' name 'NetsendUnicastSendMsgW';stdcall;
function NetsendUnicastSendMsgEx; external 'wsnslib.dll' name 'NetsendUnicastSendMsgExW';stdcall;
function NetsendUnicastGetState; external 'wsnslib.dll' name 'NetsendUnicastGetStateW';stdcall;
function NetsendUnicastSetSendTimeout; external 'wsnslib.dll' name 'NetsendUnicastSetSendTimeoutW';stdcall;
function NetsendBroadcastInitialize; external 'wsnslib.dll' name 'NetsendBroadcastInitializeW';stdcall;
function NetsendBroadcastFinalize; external 'wsnslib.dll' name 'NetsendBroadcastFinalizeW';stdcall;
function NetsendBroadcastActivate; external 'wsnslib.dll' name 'NetsendBroadcastActivateW';stdcall;
function NetsendBroadcastDeactivate; external 'wsnslib.dll' name 'NetsendBroadcastDeactivateW';stdcall;
function NetsendBroadcastSetOnNewMsg; external 'wsnslib.dll' name 'NetsendBroadcastSetOnNewMsgW';stdcall;
function NetsendBroadcastSendMsg; external 'wsnslib.dll' name 'NetsendBroadcastSendMsgW';stdcall;
function NetsendBroadcastSendMsgEx; external 'wsnslib.dll' name 'NetsendBroadcastSendMsgExW';stdcall;
function NetsendBroadcastGetState; external 'wsnslib.dll' name 'NetsendBroadcastGetStateW';stdcall;
{$ELSE}
function NetsendUnicastInitialize; external 'wsnslib.dll' name 'NetsendUnicastInitializeA';stdcall;
function NetsendUnicastFinalize; external 'wsnslib.dll' name 'NetsendUnicastFinalizeA';stdcall;
function NetsendUnicastActivate; external 'wsnslib.dll' name 'NetsendUnicastActivateA';stdcall;
function NetsendUnicastDeactivate; external 'wsnslib.dll' name 'NetsendUnicastDeactivateA';stdcall;
function NetsendUnicastAddName; external 'wsnslib.dll' name 'NetsendUnicastAddNameA';stdcall;
function NetsendUnicastDelName; external 'wsnslib.dll' name 'NetsendUnicastDelNameA';stdcall;
function NetsendUnicastSetOnNewMsg; external 'wsnslib.dll' name 'NetsendUnicastSetOnNewMsgA';stdcall;
function NetsendUnicastSendMsg; external 'wsnslib.dll' name 'NetsendUnicastSendMsgA';stdcall;
function NetsendUnicastSendMsgEx; external 'wsnslib.dll' name 'NetsendUnicastSendMsgExA';stdcall;
function NetsendUnicastGetState; external 'wsnslib.dll' name 'NetsendUnicastGetStateA';stdcall;
function NetsendUnicastSetSendTimeout; external 'wsnslib.dll' name 'NetsendUnicastSetSendTimeoutA';stdcall;
function NetsendBroadcastInitialize; external 'wsnslib.dll' name 'NetsendBroadcastInitializeA';stdcall;
function NetsendBroadcastFinalize; external 'wsnslib.dll' name 'NetsendBroadcastFinalizeA';stdcall;
function NetsendBroadcastActivate; external 'wsnslib.dll' name 'NetsendBroadcastActivateA';stdcall;
function NetsendBroadcastDeactivate; external 'wsnslib.dll' name 'NetsendBroadcastDeactivateA';stdcall;
function NetsendBroadcastSetOnNewMsg; external 'wsnslib.dll' name 'NetsendBroadcastSetOnNewMsgA';stdcall;
function NetsendBroadcastSendMsg; external 'wsnslib.dll' name 'NetsendBroadcastSendMsgA';stdcall;
function NetsendBroadcastSendMsgEx; external 'wsnslib.dll' name 'NetsendBroadcastSendMsgExA';stdcall;
function NetsendBroadcastGetState; external 'wsnslib.dll' name 'NetsendBroadcastGetStateA';stdcall;
{$ENDIF}


end.
