/******************************************************
*                                                     *  
*       Winsent Net Send SDK                          *  
*                                                     *  
*       Winsent Net Send SDK Library Interface Unit   *  
*                                                     *  
*       Copyright (c) 2010-2014, Winsent Lab          *  
*       http://www.winsentlab.com                     *  
*                                                     *  
*                                                     *  
*******************************************************/

#ifndef WSNETSENDLIB_H
#define WSNETSENDLIB_H


const int WSNS_RESULT_SUCCESS				= 0;
const int WSNS_RESULT_NOTINITIALIZED		= 1;
const int WSNS_RESULT_ALREADYINITIALIZED	= 2;

const int WSNS_RESULT_SENDUNKNOWNERROR		= 101;
const int WSNS_RESULT_SENDRECIPIENTNOTFOUND	= 102;
const int WSNS_RESULT_SENDTRANSMISSIONERROR	= 103;

const int WSNS_STATE_UNKNOWN = 0;
const int WSNS_STATE_NONETWORK = 1;
const int WSNS_STATE_INACTIVE = 2;
const int WSNS_STATE_ACTIVATION = 3;
const int WSNS_STATE_ACTIVE = 4;


typedef  void  (CALLBACK * PFNCallbackNewMsgA)(LPCSTR aFrom, LPCSTR aTo, LPCSTR aMsg);
typedef  void  (CALLBACK * PFNCallbackNewMsgW)(LPCWSTR aFrom, LPCWSTR aTo, LPCWSTR aMsg);


int __stdcall NetsendUnicastInitializeA();
int __stdcall NetsendUnicastInitializeW();
int __stdcall NetsendUnicastFinalizeA();
int __stdcall NetsendUnicastFinalizeW();
int __stdcall NetsendUnicastActivateA();
int __stdcall NetsendUnicastActivateW();
int __stdcall NetsendUnicastDeactivateA();
int __stdcall NetsendUnicastDeactivateW();
int __stdcall NetsendUnicastAddNameA( LPCSTR aName );
int __stdcall NetsendUnicastAddNameW( LPCWSTR aName );
int __stdcall NetsendUnicastDelNameA( LPCSTR aName );
int __stdcall NetsendUnicastDelNameW( LPCWSTR aName );
int __stdcall NetsendUnicastSetOnNewMsgA( PFNCallbackNewMsgA aCallback );
int __stdcall NetsendUnicastSetOnNewMsgW( PFNCallbackNewMsgW aCallback );
int __stdcall NetsendUnicastSendMsgA( LPCSTR aAddr, LPCSTR aMsg);
int __stdcall NetsendUnicastSendMsgW( LPCWSTR aAddr, LPCWSTR aMsg);
int __stdcall NetsendUnicastSendMsgExA( LPCSTR aAddr, LPCSTR aMsg, LPCSTR aSign);
int __stdcall NetsendUnicastSendMsgExW( LPCWSTR aAddr, LPCWSTR aMsg, LPCWSTR aSign);
int __stdcall NetsendUnicastGetStateA( LPCSTR aName, DWORD * aState );
int __stdcall NetsendUnicastGetStateW( LPCWSTR aName, DWORD * aState );
int __stdcall NetsendUnicastSetSendTimeoutA( DWORD aTimeout );
int __stdcall NetsendUnicastSetSendTimeoutW( DWORD aTimeout );

int __stdcall NetsendBroadcastInitializeA();
int __stdcall NetsendBroadcastInitializeW();
int __stdcall NetsendBroadcastFinalizeA();
int __stdcall NetsendBroadcastFinalizeW();
int __stdcall NetsendBroadcastActivateA();
int __stdcall NetsendBroadcastActivateW();
int __stdcall NetsendBroadcastDeactivateA();
int __stdcall NetsendBroadcastDeactivateW();
int __stdcall NetsendBroadcastSetOnNewMsgA( PFNCallbackNewMsgA aCallback );
int __stdcall NetsendBroadcastSetOnNewMsgW( PFNCallbackNewMsgW aCallback );
int __stdcall NetsendBroadcastSendMsgA( LPCSTR aAddr, LPCSTR aMsg);
int __stdcall NetsendBroadcastSendMsgW( LPCWSTR aAddr, LPCWSTR aMsg);
int __stdcall NetsendBroadcastSendMsgExA( LPCSTR aAddr, LPCSTR aMsg, LPCSTR aSign);
int __stdcall NetsendBroadcastSendMsgExW( LPCWSTR aAddr, LPCWSTR aMsg, LPCWSTR aSign);
int __stdcall NetsendBroadcastGetStateA( DWORD * aState );
int __stdcall NetsendBroadcastGetStateW( DWORD * aState );


#ifdef UNICODE
#define NetsendUnicastInitialize  NetsendUnicastInitializeW
#define NetsendUnicastFinalize  NetsendUnicastFinalizeW
#define NetsendUnicastActivate  NetsendUnicastActivateW
#define NetsendUnicastDeactivate  NetsendUnicastDeactivateW
#define NetsendUnicastAddName  NetsendUnicastAddNameW
#define NetsendUnicastDelName  NetsendUnicastDelNameW
#define NetsendUnicastSetOnNewMsg  NetsendUnicastSetOnNewMsgW
#define NetsendUnicastSendMsg  NetsendUnicastSendMsgW
#define NetsendUnicastSendMsgEx  NetsendUnicastSendMsgExW
#define NetsendUnicastGetState  NetsendUnicastGetStateW
#define NetsendUnicastSetSendTimeout  NetsendUnicastSetSendTimeoutW
#define NetsendBroadcastInitialize  NetsendBroadcastInitializeW
#define NetsendBroadcastFinalize  NetsendBroadcastFinalizeW
#define NetsendBroadcastActivate  NetsendBroadcastActivateW
#define NetsendBroadcastDeactivate  NetsendBroadcastDeactivateW
#define NetsendBroadcastSetOnNewMsg  NetsendBroadcastSetOnNewMsgW
#define NetsendBroadcastSendMsg  NetsendBroadcastSendMsgW
#define NetsendBroadcastSendMsgEx  NetsendBroadcastSendMsgExW
#define NetsendBroadcastGetState  NetsendBroadcastGetStateW
#else
#define NetsendUnicastInitialize  NetsendUnicastInitializeA
#define NetsendUnicastFinalize  NetsendUnicastFinalizeA
#define NetsendUnicastActivate  NetsendUnicastActivateA
#define NetsendUnicastDeactivate  NetsendUnicastDeactivateA
#define NetsendUnicastAddName  NetsendUnicastAddNameA
#define NetsendUnicastDelName  NetsendUnicastDelNameA
#define NetsendUnicastSetOnNewMsg  NetsendUnicastSetOnNewMsgA
#define NetsendUnicastSendMsg  NetsendUnicastSendMsgA
#define NetsendUnicastSendMsgEx  NetsendUnicastSendMsgExA
#define NetsendUnicastGetState  NetsendUnicastGetStateA
#define NetsendUnicastSetSendTimeout  NetsendUnicastSetSendTimeoutA
#define NetsendBroadcastInitialize  NetsendBroadcastInitializeA
#define NetsendBroadcastFinalize  NetsendBroadcastFinalizeA
#define NetsendBroadcastActivate  NetsendBroadcastActivateA
#define NetsendBroadcastDeactivate  NetsendBroadcastDeactivateA
#define NetsendBroadcastSetOnNewMsg  NetsendBroadcastSetOnNewMsgA
#define NetsendBroadcastSendMsg  NetsendBroadcastSendMsgA
#define NetsendBroadcastSendMsgEx  NetsendBroadcastSendMsgExA
#define NetsendBroadcastGetState  NetsendBroadcastGetStateA
#endif // !UNICODE


#endif